SET PROCEDURE TO Main.prg
CLOSE DATABASES ALL
RELEASE ALL
CLEAR ALL
LOCAL ln1, loAsk, lnTry, llWin, lnCnt
m.loAsk = CREATEOBJECT("Ask")
m.lnTry = 1
m.llWin = .F.

CREATE CURSOR csrNumbers (nN I)
FOR m.ln1 = 0 TO 9
	INSERT INTO csrNumbers (nN) VALUES (m.ln1)
ENDFOR

SELECT c1.nN AS n1, c2.nN AS n2, c3.nN AS n3, c4.nN AS n4 ;
	FROM csrNumbers c1, csrNumbers c2, csrNumbers c3, csrNumbers c4 ;
	WHERE c1.nN # c2.nN AND c1.nN # c3.nN AND c1.nN # c4.nN AND ;
		c2.nN # c3.nN AND c2.nN # c4.nN AND c3.nN # c4.nN ;
	INTO CURSOR csrPermut ;
	ORDER BY 1, 2, 3, 4
m.lnVariants = RECCOUNT ("csrPermut")

CREATE CURSOR csrReplays (n1 I, n2 I, n3 I, n4 I, nBulls I, nCows I)

DO WHILE !m.llWin

	IF m.lnTry = 1
		*     :
		SELECT csrReplays
		GO (INT(RAND(0) * RECCOUNT("csrPermut")) + 1) IN csrPermut
		INSERT INTO csrReplays (n1, n2, n3, n4, nBulls, nCows) VALUES (csrPermut.n1, csrPermut.n2, ;
			csrPermut.n3, csrPermut.n4, 0, 0)
	ELSE
		*      :
		SELECT csrResult
		GO (INT(RAND(0) * RECCOUNT("csrResult")) + 1) IN csrResult
		INSERT INTO csrReplays (n1, n2, n3, n4, nBulls, nCows) VALUES (csrResult.n1, csrResult.n2, ;
			csrResult.n3, csrResult.n4, 0, 0)
	ENDIF

	GO BOTTOM IN csrReplays
	m.loAsk.lblTry.Caption = "  " + TRANSFORM(m.lnTry)
	m.loAsk.lblNumber.Caption = TRANSFORM (csrReplays.n1) + " " + ;
		TRANSFORM (csrReplays.n2) + " " + ;
		TRANSFORM (csrReplays.n3) + " " + ;
		TRANSFORM (csrReplays.n4)
	m.loAsk.txtBulls.Value = csrReplays.nBulls
	m.loAsk.txtCows.Value = csrReplays.nCows
	m.loAsk.lblVariants.Caption = " " + TRANSFORM(m.lnVariants) + " "
	m.loAsk.Show(1)
	REPLACE csrReplays.nBulls WITH m.loAsk.txtBulls.Value, csrReplays.nCows WITH m.loAsk.txtCows.Value

	m.lnCnt = RECCOUNT("csrReplays")
	SELECT csrPermut.n1, csrPermut.n2, ;
			csrPermut.n3, csrPermut.n4 ;
		FROM csrPermut, csrReplays ;
		WHERE (csrReplays.nBulls = IIF (csrPermut.n1 = csrReplays.n1, 1, 0) + ;
			IIF (csrPermut.n2 = csrReplays.n2, 1, 0) + ;
			IIF (csrPermut.n3 = csrReplays.n3, 1, 0) + ;
			IIF (csrPermut.n4 = csrReplays.n4, 1, 0)) AND ;
			(csrReplays.nCows = IIF (csrPermut.n1 = csrReplays.n2 OR csrPermut.n1 = csrReplays.n3 OR csrPermut.n1 = csrReplays.n4, 1, 0) + ;
			IIF (csrPermut.n2 = csrReplays.n1 OR csrPermut.n2 = csrReplays.n3 OR csrPermut.n2 = csrReplays.n4, 1, 0) + ;
			IIF (csrPermut.n3 = csrReplays.n1 OR csrPermut.n3 = csrReplays.n2 OR csrPermut.n3 = csrReplays.n4, 1, 0) + ;
			IIF (csrPermut.n4 = csrReplays.n1 OR csrPermut.n4 = csrReplays.n2 OR csrPermut.n4 = csrReplays.n3, 1, 0)) ;
		INTO CURSOR csrResult;
		GROUP BY csrPermut.n1, csrPermut.n2, ;
			csrPermut.n3, csrPermut.n4 ;
		HAVING COUNT (*) = m.lnCnt
	m.lnVariants = _TALLY
	IF m.lnVariants = 1
		MESSAGEBOX ("  - " + TRANSFORM (csrResult.n1) + " " + ;
		TRANSFORM (csrResult.n2) + " " + ;
		TRANSFORM (csrResult.n3) + " " + ;
		TRANSFORM (csrResult.n4) + ;
		"   " + TRANSFORM (m.lnTry + IIF (m.loAsk.txtBulls.Value = 4, 0, 1)) + ;
		" ", ;
		0, " !!!")
		RETURN .T.
	ENDIF
	IF m.lnVariants = 0
		MESSAGEBOX ("  !!!    !!!", ;
		0, "!!!")
		SELECT csrReplays
		GO TOP
		BROWSE FIELDS n1:H="":2, n2:H="":3, n3:H="":3, n4:H="":3, nBulls:H="", nCows:H="" ;
			NOAPPEND NODELETE NOMODIFY TITLE "  :) -    :)))"
		RETURN .F.
	ENDIF
	m.lnTry= m.lnTry + 1
ENDDO

DEFINE CLASS ask AS Form
	Caption = " "
	Width = 170
	Height = 170
	AutoCenter = .T.

	ADD OBJECT lblTry AS Label WITH Left = 10, Top = 10, Autosize = .T.
	ADD OBJECT lblNumber AS Label WITH Left = 20, Top = 30, Autosize = .T., ;
		FontBold = .T., FontSize = 10
	ADD OBJECT lblBulls AS Label WITH Left = 10, Top = 60, Autosize = .T., Caption = ":"
	ADD OBJECT txtBulls AS Textbox WITH Left = 70, Top = 60, Width = 50, Value = 0, InputMask = "9"
	ADD OBJECT lblCows AS Label WITH Left = 10, Top = 90, Autosize = .T., Caption = ":"
	ADD OBJECT txtCows AS Textbox WITH Left = 70, Top = 90, Width = 50, Value = 0, InputMask = "9"
	ADD OBJECT cmdOK AS CommandButton WITH Left = 20, Top = 120, Width = 80, Caption = ""
	ADD OBJECT lblVariants AS Label WITH Left = 10, Top = 150, Autosize = .T.

	PROCEDURE cmdOK.Click
		ThisForm.Hide()
	ENDPROC

	PROCEDURE QueryUnload
		NODEFAULT
		ThisForm.Hide()
	ENDPROC

ENDDEFINE